/**************************************************************************  *RatNum.h 
 *
 *  Purpose:  Declares the class RatNum (RatNumNumber)
****************************************************************************/
#ifndef RATNUM		//compile-once wrapper
#define RATNUM

#include <iostream>
using namespace std;

class RatNum
{
      public:

		RatNum ();												//default-value constructor
		RatNum (int numerator, int denominator);	//explicit-value constructor

		void SetA(int numerator);							//Change value of A
		void SetB(int denominator);						//Change value of B
		int A() const;											//Gives value of A
		int B() const;											//Gives value of B

		//overloaded operators
		RatNum operator +( const RatNum &r ) const;
		RatNum operator -( const RatNum &r ) const;
		RatNum operator *( const RatNum &r ) const;
		RatNum operator /( const RatNum &r ) const;
		bool operator ==( const RatNum &r ) const;
		bool operator >( const RatNum &r ) const;
		bool operator <( const RatNum &r ) const;
		bool operator >=( const RatNum &r ) const;
		bool operator <=( const RatNum &r ) const;

		//rational number functions
		int lcd( RatNum r1, RatNum r2 ) const;
		int gcf( int num1, int num2 ) const;
		RatNum reduce( RatNum &r ) const;

      private:

		int  myA, myB;	//denominator
};



//----------Change value of A----------------
inline void RatNum::SetA (int numerator)
{
	myA = numerator;
}

//--------Change value of B-----------
inline void RatNum::SetB (int denominator)
{
	myB = denominator;
}

//-------Return value of A-----------
inline int RatNum::A () const
{
	return myA;
}

//-------Return value of B----------
inline int RatNum::B () const
{
	return myB;
}

//--------Overload output operator--------------
inline ostream & operator<< (ostream & out, RatNum & num)
{
	out << num.A() << "/" << num.B();
	return out;
}

//--------Overload input operator---------------
inline istream & operator>> (istream & in, RatNum & num)
{
	char punc;
	int a, b;
	in >> a >> punc >> b; //input will be in form of 'a/b'
	num.SetA(a);
	num.SetB(b);
	return in;
}

#endif
